ListKong/Controllers/CompanyController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    [Authorize]
    public class CompanyController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;
        
        public CompanyController(IConfiguration configuration)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
        }
        #endregion
        public async Task<IActionResult> Index()
        {
            try
            {
                CompanyModel model = new CompanyModel();
                var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
                List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
                parameters.Add(new KeyValuePair<string, string>("@userId", userId));
                DataSet ds = _objDataHelper.ExecuteProcedureWithDataSet("app_Get_Company_By_UserId", parameters);
                if (ds.Tables.Count > 0)
                {
                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        model.CompanyId = Convert.ToInt32(ds.Tables[0].Rows[0]["CompanyID"]);
                        model.CompanyName = Convert.ToString(ds.Tables[0].Rows[0]["CompanyName"]);
                        model.Address = Convert.ToString(ds.Tables[0].Rows[0]["Address"]);
                        model.ContactName = Convert.ToString(ds.Tables[0].Rows[0]["ContactName"]);
                        model.Email = Convert.ToString(ds.Tables[0].Rows[0]["Email"]);
                        model.Description = Convert.ToString(ds.Tables[0].Rows[0]["Description"]);
                        HttpContext.Session.SetString("_CompanyName", model.CompanyName);
                        HttpContext.Session.SetString("_CompanyId", Convert.ToString(model.CompanyId));
                    }
                    else
                    {
                        model = new CompanyModel();
                    }
                }
                return View(model);
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View();
            }
            return View();
        }
        [HttpPost]
        public async Task<IActionResult> Edit(CompanyModel model)
        {
            if (!ModelState.IsValid)
            {
                return View(model);
            }
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            parameters.Add(new KeyValuePair<string, string>("@companyId", Convert.ToString(model.CompanyId)));
            parameters.Add(new KeyValuePair<string, string>("@CompanyName", Convert.ToString(model.CompanyName)));
            parameters.Add(new KeyValuePair<string, string>("@Address", model.Address));
            parameters.Add(new KeyValuePair<string, string>("@ContactName", Convert.ToString(model.ContactName)));
            parameters.Add(new KeyValuePair<string, string>("@Email", model.Email));
            parameters.Add(new KeyValuePair<string, string>("@Description", model.Description));
            DataTable dt = _objDataHelper.ExecuteProcedure("app_Update_Company", parameters);
            if (dt != null && dt.Rows.Count > 0)
            {
                string companyName = Convert.ToString(model.CompanyName);
                HttpContext.Session.SetString("_CompanyName", companyName);
                HttpContext.Session.SetString("_CompanyId", Convert.ToString(dt.Rows[0]["CompanyId"]));
                ViewData["SuccessMessage"] = "Company successfully updated!";
            }
            TempData["SuccessMessage"] = "Company successfully updated!";
            return RedirectToAction("Index");
        }
        public DataTable CompanyList()
        {
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            List<KeyValuePair<string, string>> parameters = new List<KeyValuePair<string, string>>();
            parameters.Add(new KeyValuePair<string, string>("@userId", userId));
            return _objDataHelper.ExecuteProcedure("app_Get_All_Company_By_Admin_User", parameters);
        }
    }
}

ListKong/Controllers/ReportsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Linq;
using System.Threading.Tasks;
using ListKong.Models;
using ListKong.Utility;
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.Extensions.Configuration;

namespace ListKong.Controllers
{
    [Authorize]
    public class ReportsController : Controller
    {
        #region Controller Properties
        private IConfiguration _configuration;
        private CommonHelper _objHelper;
        private SQLGateway _objDataHelper;
        public string cnnect;
        public string keyForEncrypt, encryptedToken, encryptedEmail, formFlag;

        public ReportsController(IConfiguration configuration)
        {
            this._configuration = configuration;
            this._objDataHelper = new SQLGateway(this._configuration.GetConnectionString("DefaultConnection"));
            this._objHelper = new CommonHelper(this._configuration);
            cnnect = this._configuration.GetConnectionString("DefaultConnection");
        }
        #endregion
        public IActionResult InventoryReport()
        {
            try
            {
                string companyName = HttpContext.Session.GetString("_CompanyName");
                this.ViewData["companyName"] = companyName;
                InventoryReportModel model = new InventoryReportModel();
                model.listing = new List<InventoryListReportModel>();
                return View(model);
                //DataTable _dtResponseP = InventoryList();
                //if (this._objHelper.checkDBNullResponse(_dtResponseP))
                //{
                //    List<InventoryListModel> lst = new List<InventoryListModel>();
                //    lst = ExtensionMethods.DataTableToList<InventoryListModel>(_dtResponseP);
                //    return View(lst);
                //}
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View();
            }
            return View();
        }
        [HttpPost]
        public IActionResult InventoryReport(InventoryReportModel model)
        {
            string companyName = HttpContext.Session.GetString("_CompanyName");
            this.ViewData["companyName"] = companyName;
            try
            {
                if (!string.IsNullOrEmpty(Convert.ToString(model.startDate)) && !string.IsNullOrEmpty(Convert.ToString(model.startTime)))
                {
                    TimeSpan tsStartTime = DateTime.Parse(model.startTime).TimeOfDay;
                    TimeSpan tsEndTime = DateTime.Parse(model.endTime).TimeOfDay;
                    DateTime sdate = Convert.ToDateTime(model.startDate);
                    DateTime edate = Convert.ToDateTime(model.endDate);
                    sdate = Convert.ToDateTime(sdate.Add(tsStartTime));
                    edate = Convert.ToDateTime(edate.Add(tsEndTime));
                    //DateTime sDate=model.startDate.Value.t
                    DataTable _dtResponseP = InventoryList(sdate, edate);
                    if (this._objHelper.checkDBNullResponse(_dtResponseP))
                    {
                        List<InventoryListReportModel> lst = new List<InventoryListReportModel>();
                        lst = ExtensionMethods.DataTableToList<InventoryListReportModel>(_dtResponseP);
                        model.listing = lst;
                        return View(model);
                    }
                }
                else
                {
                    model.listing = new List<InventoryListReportModel>();
                    return View(model);
                }
            }
            catch (Exception ex)
            {
                string E = ex.Message.ToString();
                return View(model);
            }
            return View(model);
        }
        public DataTable InventoryList(DateTime startDate, DateTime endDate)
        {
            var userId = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.xmlsoap.org/ws/2005/05/identity/claims/nameidentifier").Value;
            var role = @User.Claims.FirstOrDefault(c => c.Type == "http://schemas.microsoft.com/ws/2008/06/identity/claims/role").Value;
            List<KeyValuePair<string, object>> parameters = new List<KeyValuePair<string, object>>();
            parameters.Add(new KeyValuePair<string, object>("@userId", userId));
            parameters.Add(new KeyValuePair<string, object>("@role", role));
            parameters.Add(new KeyValuePair<string, object>("@startDate", startDate));
            parameters.Add(new KeyValuePair<string, object>("@endDate", endDate));
            return _objDataHelper.ExecuteProcedureWithObject("app_Get_All_Inventory_Report", parameters);
        }
    }
}

ListKong/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html>
<head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>@ViewData["Title"] - ListKong</title>

    <environment include="Development">
        <link rel="stylesheet" href="~/lib/bootstrap/dist/css/bootstrap.css" />
        <link rel="stylesheet" href="~/css/site.css" />
    </environment>
    <environment exclude="Development">
        <link rel="stylesheet" href="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/css/bootstrap.min.css"
              asp-fallback-href="~/lib/bootstrap/dist/css/bootstrap.min.css"
              asp-fallback-test-class="sr-only" asp-fallback-test-property="position" asp-fallback-test-value="absolute" />
        <link rel="stylesheet" href="~/css/site.min.css" asp-append-version="true" />
    </environment>
    <link rel="stylesheet" href="https://stackpath.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css" />
    <link rel="stylesheet" href="//cdn.jsdelivr.net/npm/alertifyjs@1.13.1/build/css/alertify.min.css">

    <environment include="Development">

        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-2.2.0.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-K+ctZQ+LL8q6tP7I94W+qzQsfRV2a+AfHIi9k8z8l9ggpc8X+Ytst4yBo/hH+8Fk">
        </script>
        <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa">
        </script>
        <script src="~/lib/jquery/dist/jquery.js"></script>
        <script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
        <script src="~/js/site.js" asp-append-version="true"></script>
        <script src="//cdn.jsdelivr.net/npm/alertifyjs@1.13.1/build/alertify.min.js"></script>
    </environment>
    <environment exclude="Development">
        <script src="https://ajax.aspnetcdn.com/ajax/jquery/jquery-2.2.0.min.js"
                asp-fallback-src="~/lib/jquery/dist/jquery.min.js"
                asp-fallback-test="window.jQuery"
                crossorigin="anonymous"
                integrity="sha384-K+ctZQ+LL8q6tP7I94W+qzQsfRV2a+AfHIi9k8z8l9ggpc8X+Ytst4yBo/hH+8Fk">
        </script>
        <script src="https://ajax.aspnetcdn.com/ajax/bootstrap/3.3.7/bootstrap.min.js"
                asp-fallback-src="~/lib/bootstrap/dist/js/bootstrap.min.js"
                asp-fallback-test="window.jQuery && window.jQuery.fn && window.jQuery.fn.modal"
                crossorigin="anonymous"
                integrity="sha384-Tc5IQib027qvyjSMfHjOMaLkfuWVxZxUPnCJA7l2mCWNIpG9mGCD8wGNIcPD7Txa">
        </script>
        <script src="//ajax.googleapis.com/ajax/libs/jquery/1.9.1/jquery.min.js"></script>
        <script src="~/js/site.min.js" asp-append-version="true"></script>
        <script src="//cdn.jsdelivr.net/npm/alertifyjs@1.13.1/build/alertify.min.js"></script>
    </environment>
    <style>
        .companymenuli a:hover {
            color: #fff;
            text-decoration: none;
            cursor: pointer;
            /*padding-top: 10px;*/
            /*padding-left: 24px;
            padding-right: 23px;
            padding-bottom: 11px;*/
            /*background-color: #fff;*/
            border-top: 2px solid #999;
            margin-top: -2px;
        }

        .companymenuli:hover > ul {
            display: block;
            background-color: #999;
            color: #FFF;
            height:30px;
            margin-top:-10px;
        }
        .submenu {
            display: none;
            position: absolute;
            z-index: 1;
            width: 200px;
            height:auto !important;
        }

            .submenu li {
                list-style-type: none;
                margin-left: -20px;
                margin-top: 5px;
                cursor:pointer;
            }
    </style>
</head>
<body>
    <nav class="navbar navbar-inverse navbar-fixed-top">
        <div class="container">
            <div class="navbar-header">
                <button type="button" class="navbar-toggle" data-toggle="collapse" data-target=".navbar-collapse">
                    <span class="sr-only">Toggle navigation</span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                    <span class="icon-bar"></span>
                </button>
                <a asp-area="" asp-controller="Home" asp-action="Index" class="navbar-brand">ListKong</a>
            </div>
            <div class="navbar-collapse collapse">
                <ul class="nav navbar-nav">
                    <li><a asp-area="" asp-controller="Home" asp-action="Index">Home</a></li>

                    @if (User.Identity.IsAuthenticated)
                    {
                        @*if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Company" asp-action="Index">Manage Company</a>
                            </li>
                        }*@
                        if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="Location" asp-action="Index">Manage Locations</a>
                            </li>
                        }
                        if (User.IsInRole("Admin"))
                        {
                            <li class="nav-item">
                                <a class="nav-link text-dark" asp-area="" asp-controller="CompanyUser" asp-action="Index">Manage User</a>
                            </li>
                        }
                        <li class="nav-item">
                            <a class="nav-link text-dark" asp-area="" asp-controller="Inventory" asp-action="Index">Manage Inventory</a>
                        </li>
                        if (User.IsInRole("Admin"))
                        {

                            <li class="nav-item companymenuli">
                                <a class="nav-link text-dark">Report <b class="caret"></b></a>
                                <ul class="submenu">
                                    @{
                                        string result = string.Empty;
                                        var sessionName = new Byte[20];
                                        bool nameOK = Context.Session.TryGetValue("_CompanyName", out sessionName);

                                        if (nameOK)
                                        {
                                            result = System.Text.Encoding.UTF8.GetString(sessionName);
                                            <li><a class="nav-link text-dark" style="color:#fff;" asp-area="" asp-controller="Reports" asp-action="InventoryReport">Inventory Report</a>
                                     </li>
                                        }
                                    }

                                </ul>
                            </li>
                        }
                    }
                    else
                    {
                        @*<li><a asp-area="" asp-controller="Home" asp-action="About">About</a></li>
                            <li><a asp-area="" asp-controller="Home" asp-action="Contact">Contact</a></li>*@
                    }
                </ul>
                @await Html.PartialAsync("_LoginPartial")
            </div>
        </div>
    </nav>
    <div class="container body-content">
        @RenderBody()
        <hr />
        <footer id="footer">
            <p>&copy; 2020 - ListKong</p>
        </footer>
    </div>

    @RenderSection("Scripts", required: false)
</body>
</html>